<?
//    -------------------------------------------------------------------------
//    $Id: ErrorHandler.php,v 1.3 2002/12/13 09:19:32 joko Exp $
//    -------------------------------------------------------------------------
//    $Log: ErrorHandler.php,v $
//    Revision 1.3  2002/12/13 09:19:32  joko
//    + debugging
//
//    Revision 1.2  2002/12/01 04:47:19  joko
//    + comments
//
//    Revision 1.1  2002/11/12 05:42:30  joko
//    + initial checkin
//
//    -------------------------------------------------------------------------


// TODO: maybe use and/or enhance ErrorHandler from http://phpclasses.php-start.de/browse.html/package/345.html

function error_handler($level, $message, $file, $line, $context) {
  global $Application_Error;
  $Application_Error['this']->callErrorHandler($level, $message, $file, $line, $context);
}

class Application_ErrorHandler {

  function Application_ErrorHandler(&$debugbox) {
    $this->QUIET = 1;
    $this->debugbox = $debugbox;
  }

  function activate($level = E_ALL) {
    //return;
//print "1<br>";
//exit;
    global $Application_Error;
//print "2<br>";
    $Application_Error[this] = $this;
//print "3<br>";
    //error_reporting($level);
    error_reporting(E_ALL);
//print "4<br>";
    set_error_handler('error_handler');
//print "5<br>";
  }

  function callErrorHandler($level, $message, $file, $line, $context) { 
  
    $phperror_type = array (
      1   =>  "Error",
      2   =>  "Warning",
      4   =>  "Parsing Error",
      8   =>  "Notice",
      16  =>  "Core Error",
      32  =>  "Core Warning",
      64  =>  "Compile Error",
      128 =>  "Compile Warning",
      256 =>  "User Error",
      512 =>  "User Warning",
      1024=>  "User Notice"
    );
  
    $level_text = $phperror_type[$level];
  
      if ($level == E_USER_NOTICE) {
        $phperror = $message;
      } else {
      
      $phperror = "
PHP-Error:
level: $level ($level_text)
file: $file
line: $line
The error message was: $message 
      ";
      }
      
      //The following variables were set in the scope that the error occurred in: 
      //" . dumpVar($context);
  
      if ($this->debugbox) {
        $this->debugbox->append($phperror, $level);
      }
      
      if (isset($this->site)) {
  
        // logging mechanism
        $this->site->log($phperror, LOG_ERR);
  
        // redirection to "STDOUT", make html for output
        if ($this->site->config['mode']['PHPERRORS_LEVEL']) { 
          if ($level <= $this->site->config['mode']['PHPERRORS_LEVEL']) {
            $phperror = str_replace("\n", "<br>", $phperror);
            print $phperror; 
          }
        }
  
      } elseif (!$this->QUIET) {
        $phperror = str_replace("\n", "<br>", $phperror);
        print $phperror; 
      }
    
      if ($level < E_ERROR) {
        // TODO: logfile?
        print $message . "<br>";
      }
    
      //print_r ($context); 
      //print "\n</blockquote>"; 
  }

}

?>