<?
##    --------------------------------------------------------------------------
##    $Id: Remote.php,v 1.5 2002/12/22 13:24:09 jonen Exp $
##    --------------------------------------------------------------------------
##    $Log: Remote.php,v $
##    Revision 1.5  2002/12/22 13:24:09  jonen
##    + added utf8 encoding at 'send()' toggled by option
##
##    Revision 1.4  2002/12/19 02:02:25  jonen
##    + minor changes
##
##    Revision 1.3  2002/12/19 01:59:37  jonen
##    + minor changes: coment debug prints
##
##    Revision 1.2  2002/12/05 21:45:31  joko
##    + debugging
##
##    Revision 1.1  2002/12/01 17:23:58  joko
##    + initial check-in
##
##    Revision 1.3  2002/12/01 06:22:57  cvsjoko
##    + minor update: now can use config defaults or given args
##
##    Revision 1.2  2002/10/29 19:14:45  cvsjoko
##    - bugfix: dont' do utf8-encoding here
##
##    Revision 1.1  2002/10/09 00:51:39  cvsjoko
##    + new
##
##
##    -------------------------------------------------------------------------

class Remote {
  
  function Remote($args = array()) {
    global $cfg;
    //print "new Remote<br>";
    $this->host = $cfg[rpcinfo][Host];
    $this->port = $cfg[rpcinfo][Port];
    if ($args['Host']) { $this->host = $args['Host']; }
    if ($args['Port']) { $this->port = $args['Port']; }
  }

  function send($command, $data = "", $options = array()) {
    // do 'encode' here and ...
    if ($options[utf8]) {
      $encoder = new TextEncode($data);
      $encoder->toUTF8();
    }
    // call '_call' with 'decode'
    return $this->_call($command, $data, 1);
  }

  function _call($command, $data = "", $decode = 0) {

   //print "call: $command<hr>";
 
// print Dumper($data);

    // data
      $data_enc = XML_RPC_encode($data);

    // message - request
      $msg = new XML_RPC_Message($command);
      $msg->addParam($data_enc);
//print htmlentities($msg->serialize());
    // remote procedure call
      $rpc = new XML_RPC_Client("/", $this->host, $this->port);
      $rpc->setDebug(0);
      if ( !$msg_response = $rpc->send($msg) ) {
        // TODO: redirect this error elsewhere!
        print "RPC-error!<br>";
        return;
      }
    // message - response
      $response_enc = $msg_response->value();

      // TODO: what's this? prematurely returning here should not be considered "stable"....
      return $this->decodeData($response_enc);

    if ($decode) {
      return $this->decodeData($response_enc);
    } else {
      return $response_enc;
    }
    
  }
  
  function &decodeData(&$payload) {
    //if (!is_object($payload)) { return; }
      if ($payload) {
    // data
        $data = XML_RPC_decode($payload);
        //print "data: " . dumpVar($response);
        return $data;
      } else {
        //print "ERROR!<br>";
        return 0;
      }
  }
  
}

?>