<?
//    -------------------------------------------------------------------------
//    $Id: Session.php,v 1.8 2002/12/28 01:17:53 jonen Exp $
//    -------------------------------------------------------------------------
//    $Log: Session.php,v $
//    Revision 1.8  2002/12/28 01:17:53  jonen
//    - moved 'validate_idle()' to 'presentation.php' cause some problems
//      with '$site->request->overrideRequestIdentifer()' at class scope
//
//    Revision 1.7  2002/12/13 00:24:03  jonen
//    - added debug Dumper
//
//    Revision 1.6  2002/12/05 21:46:09  joko
//    + global $sessionstate (session-variable)
//    + function get
//    + function set
//
//    Revision 1.5  2002/12/04 10:13:21  joko
//    - purged old code in validate_session
//
//    Revision 1.3  2002/12/03 16:13:21  joko
//    + bugfix with autologout:
//      + now just setting some message to site_state here
//      + no direct getlt! (it's a shortcut function)
//      + $this->site->user->preLogout(1);  as autoload mechanism
//
//    Revision 1.2  2002/12/01 22:32:45  joko
//    + bugfix: wrong object-hierarchy:
//       use $this->site->user->preLogout and/or $this->site->request->overrideReq...
//    + documented
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    -------------------------------------------------------------------------


class Session {
  
  //============== session functions=============
  function &Session() {
    global $session_cfg;
    $session_cfg["session_id"] = session_id();
    $session_cfg["remote_ip"] = $_SERVER["REMOTE_ADDR"];
    $session_cfg["remote_port"] = $_SERVER["REMOTE_PORT"];
    $session_cfg["user_agent"] = $_SERVER["HTTP_USER_AGENT"];    
    $session_cfg["http_referer"] = $_SERVER["HTTP_REFERER"];
    $session_cfg["date"] = date('Y-m-d H:i:s', time());

    if (session_register_safe('sessionstate')) {
    }

  } 
  
  function start() {
    global $session_cfg;
    $session_exists = $this->exists($session_cfg["session_id"]);
    //print Dumper($session_exists);
    if (!is_array($session_exists)) {
      $this->add_session($session_cfg);
    } else {
      $session_cfg["session_uid"] = $session_exists["session_uid"];
      //if ($this->site->user->isLoggedOn()) {
        //print "val - idle<br>";
        //$this->validate_idle();
      //}
      //print "val - session<br>";
      //$this->validate_session($session_cfg);
    }
  }
  
  function validate_session($scfgt) {
    $this->update_session($scfgt);
  }
  
  function update_session($scfg) {
    $sql = "UPDATE f_td_sessions SET session_hits=session_hits+1,last_date='$scfg[date]' WHERE session_uid='$scfg[session_uid]'";
    $res = send_sql($sql);
  }
  
  function add_session($scfg) {
      //session_start();
      //session_register('user_status_val');
      connectdb();
      $sql="INSERT INTO f_td_sessions VALUES ('','$scfg[session_id]','1','$scfg[remote_ip]','$scfg[remote_port]','$scfg[user_agent]','$scfg[http_referer]','$scfg[date]','$scfg[date]')";
      $res = send_sql($sql);
  }
  
  function bindUser() {
    $session_id = session_id();
  	$session_tm = $this->exists($session_id);
    $date = date('Y-m-d H:i:s', time());
    $sql = "SELECT mid FROM f_map_user_session WHERE user_uid='$site->user->get('oid')' AND last='1'";
    if($res = send_sql($sql)) {
  	$row = mysql_fetch_array($res,MYSQL_ASSOC);
    //if (!mysql_num_rows($res)>0) {
      $sql2 = "INSERT INTO f_map_user_session VALUES ('','$this->site->user->get('oid')','$session_tm[session_uid]','$date','','1')";
      $res2 = send_sql($sql2);
    }
    else {
  	//print_r($row);
      $sql3 = "Update f_map_user_session SET last='0' WHERE mid='$row[mid]'";
      $res3 = send_sql($sql3);	
      $sql4 = "INSERT INTO f_map_user_session VALUES ('','$this->site->user->get('oid')','$session_tm[session_uid]','$date','','1')";
      $res4 = send_sql($sql4);
    }
  }
  
  function exists($session_id) {
    // check if sessionID exists
    connectdb();
    $sql_exists = "SELECT session_uid,session_id FROM f_td_sessions WHERE session_id='$session_id'";
    $res_exists = send_sql($sql_exists);
    if (!mysql_num_rows($res_exists) > 0) {
      return 0;
    }
    else {
  	  $row = mysql_fetch_array($res_exists, MYSQL_ASSOC);
  	  return $row;
  	}
  }  
  

  
  function get($attribute) {
    global $sessionstate;
//print "session - get: " . Dumper($sessionstate) . "<br>";
    return $sessionstate[$attribute];
  }

  function set($attribute, $value) {
    global $sessionstate;
//print "val: " . Dumper($value) . "<br>";
    $sessionstate[$attribute] = $value;
//print "session - set: " . Dumper($sessionstate) . "<br>";
  }

}

?>